# Use Maven 3.5 and JDK8
image: maven:3.5-jdk-8

variables:
  # This will supress any download for dependencies and plugins or upload messages which would clutter the console log.
  # `showDateTime` will show the passed time in milliseconds. You need to specify `--batch-mode` to make this work.
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  # As of Maven 3.3.0 instead of this you may define these options in `.mvn/maven.config` so the same config is used
  # when running from the command line.
  # `installAtEnd` and `deployAtEnd`are only effective with recent version of the corresponding plugins.
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"
  # Sonar
  SONAR_OPTS: "-Dsonar.host.url=http://5.189.184.16:9000 -Dsonar.login=dabdfeb022140413257d309036922ec39d4ec8e7"
  DOCKER_DRIVER: overlay2
  IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-$CI_COMMIT_SHA

# Cache downloaded dependencies and plugins between builds.
# To keep cache across branches add 'key: "$CI_JOB_REF_NAME"'
cache:
  paths:
    - .m2/repository
    
stages:
- build
- test
- docker
#- pull

# This will only validate and compile stuff and run e.g. maven-enforcer-plugin.
# Because some enforcer rules might check dependency convergence and class duplications
# we use `test-compile` here instead of `validate`, so the correct classpath is picked up.
compile:
  stage: build
  script:
    - 'mvn $MAVEN_CLI_OPTS test-compile'

# Run `verify`.
# See https://maven.apache.org/guides/introduction/introduction-to-the-lifecycle.html
verify:
  stage: test
  script:
    - 'mvn $MAVEN_CLI_OPTS verify sonar:sonar $SONAR_OPTS'
  artifacts:
    paths:
    - target/*.war
    
build-docker:
  stage: docker
  image: docker:latest
  services:
  - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - docker build --pull -t $IMAGE_TAG -t $CI_REGISTRY_IMAGE:latest .
    - docker tag $IMAGE_TAG $CI_REGISTRY_IMAGE:latest
    - docker push $IMAGE_TAG
    - docker push $CI_REGISTRY_IMAGE:latest
    
#docker-pull:
 # stage: pull
 # image: docker:latest
#  services:
 # - docker:dind
#  script:
  #  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
  #  - docker pull $IMAGE_TAG
 # only:
  #  - master